#include <d3dx8.h>

class CControl
{
public:
    D3DXVECTOR3 m_vPosition;
    D3DXVECTOR3 m_vAxis[3];
    D3DXMATRIX  m_mRotation;
    D3DXMATRIX  m_mTranslation;
    D3DXMATRIX  m_mTransformation;

    void Clear();

    void RotateX(float);
    void RotateY(float);
    void RotateZ(float);
    void Rotate(int, float);
   
    void TranslateX(float);
    void TranslateY(float);
    void TranslateZ(float);   
    void Translate(D3DXVECTOR3);

    void         SetPosition(D3DXVECTOR3);
    D3DXVECTOR3  GetRelativePosition(D3DXVECTOR3);
    D3DXVECTOR3  GetRelativePositionAxis(D3DXVECTOR3);
    D3DXMATRIX   GetRelativePositionMatrix(D3DXVECTOR3, bool);
    CControl     GetRelativePositionControl(D3DXVECTOR3);

    void SetAxes(D3DXVECTOR3, D3DXVECTOR3, D3DXVECTOR3);
    void SetDirection(D3DXVECTOR3, float);

    void UpdateTransformationMatrix();   
};